<template>
  <b-container fluid>
   <b-row>
      <b-col><b>Market Session::</b> {{ $route.params.sessionId }}</b-col>
      <b-col><b>Market Type:</b> {{ $route.params.marketType }}</b-col>
      <b-col><b>Date start:</b> {{ $route.params.startActivation | formatDate }}</b-col>
    </b-row>
    <br>
    <b-tabs content-class="mt-3">
      <b-tab title="Flexibility Services" active>
        <b-table  striped hover :items="flexibilityServices" :fields="fields" :current-page="currentPage" :per-page="perPage" :filter="filter" @filtered="onFiltered" class="table-platone">
          <template #cell(createdAt)="data">
            {{data.item.createdAt | formatDate}}
          </template>
          <template #cell(flexibility)="data">
            <b-button size="sm" @click="data.toggleDetails">
              {{ data.detailsShowing ? 'Hide' : 'Show' }} Details
            </b-button>
          </template>
          <template #row-details="data">
            <b-list-group>
               <b-row>
                  <b-col md="9" offset-md="9">
                      <div class="md-layout-item md-small-size-20 md-size-20 md-alignment-center-right">
                        <b-btn class="xlsx-button" @click="exportToFsExcel(data.item, data.item.serviceType)">Download Flexibility Service&nbsp;&nbsp;<b-icon icon="file-earmark-excel"/></b-btn>
                      </div>
                  </b-col>
                </b-row>
              <b-list-group-item
                v-for="result in data.item.flexibility"
                v-bind:key="result._id">
                <b-card>
                  <b-row>
                    <b-col><b>Id:</b> {{ result._id }}</b-col>
                    <b-col><b>Pod:</b> {{ result.pod.toString() }}</b-col>
                  </b-row>
                  <b-row>
                    <b-col><b>Power:</b></b-col>
                  </b-row>
                  <b-row>
                    <b-col>
                        <b-table
                          responsive
                          hover
                          bordered
                          outlined
                          small
                          :items="result.power"
                          :fields="fieldsPower"
                          class="tablePower tablePower-hover table-platone">
                          <template #cell(index)="result">
                            {{ result.item.index }}
                          </template>
                          <template #cell(p)="result">
                            {{ result.item.p ? Math.round( result.item.p* 1000)/1000
                                : result.item.p | formatNumber | formatKw}}
                          </template>
                          <template #cell(pPrice)="result">
                            {{ result.item.pPrice | formatNumber | formatPriceKw}}
                          </template>
                          <template #cell(q)="result">
                            {{ result.item.q ? Math.round( result.item.q* 1000)/1000
                                : result.item.q | formatNumber | formatQKw}}
                          </template>
                          <template #cell(qPrice)="result">
                            {{ result.item.qPrice | formatNumber | formatQPriceKw}}
                          </template>
                        </b-table>
                    </b-col>
                  </b-row>
                </b-card>
              </b-list-group-item>
            </b-list-group>
          <!--  <vue-json-pretty :data="data.item.flexibility"></vue-json-pretty>-->
          </template>
        </b-table>
        <b-row>
          <b-col md="6" class="my-1">
            <b-pagination :total-rows="totalRows" :per-page="perPage" v-model="currentPage" class="my-0" />
          </b-col>
        </b-row>
      </b-tab>
      <b-tab title="Market Outcome">
          <template>
            <b-list-group>
              <b-list-group-item
                v-for="item in marketOutcome"
                v-bind:key="item._id">
                <b-card>
                  <b-row>
                    <b-col><b>Market Outcome Id:</b> {{ item._id }}</b-col>
                    <b-col md="9" offset-md="9">
                        <div class="md-layout-item md-small-size-20 md-size-20 md-alignment-center-right">
                          <b-btn class="xlsx-button" @click="exportToMoExcel(item.flexibility, item.marketType, item.startTime)">Download Market Outcome&nbsp;&nbsp;<b-icon icon="file-earmark-excel"/></b-btn>
                        </div>
                    </b-col>
                  </b-row>
                  <b-card v-for="flex in item.flexibility" v-bind:key="flex._id" class="flex-card">
                      <b-row>
                        <b-col><b>Pod:</b> {{ flex.pod }}</b-col>
                      </b-row>
                      <b-row>
                        <b-col><b>Power:</b></b-col>
                      </b-row>
                      <b-row>
                        <b-col>
                            <b-table
                              responsive
                              hover
                              bordered
                              outlined
                              small
                              :items="flex.power"
                              :fields="fieldsMarketOutcome"
                              class="tablePower tablePower-hover table-platone">
                              <template #cell(index)="result">
                                {{ result.item.index }}
                              </template>
                              <template #cell(p)="result">
                                {{ result.item.p ? Math.round( result.item.p* 1000)/1000
                                : result.item.p | formatNumber | formatKw}}
                              </template>
                              <template #cell(priorityP)="result">
                                {{ result.item.priorityP }}
                              </template>
                              <template #cell(q)="result">
                                {{ result.item.q ? Math.round( result.item.q* 1000)/1000
                                : result.item.q | formatNumber | formatQKw}}
                              </template>
                              <template #cell(priorityQ)="result">
                                {{ result.item.priorityQ }}
                              </template>
                            </b-table>
                        </b-col>
                      </b-row>
                    </b-card>
                </b-card>
              </b-list-group-item>
            </b-list-group>
          </template>
      </b-tab>
      <b-tab title="Technical Outcome">
          <template>
            <b-list-group>
              <b-list-group-item
                v-for="to in technicalOutcome"
                v-bind:key="to._id">
                <b-card>
                  <b-row>
                    <b-col><b>Technical Outcome Id:</b> {{ to._id }}</b-col>
                    <b-col md="9" offset-md="9">
                        <div class="md-layout-item md-small-size-20 md-size-20 md-alignment-center-right">
                          <b-btn class="xlsx-button" @click="exportToToExcel(to.flexibility, to.marketType, to.startTime)">Download Technical Outcome&nbsp;&nbsp;<b-icon icon="file-earmark-excel"/></b-btn>
                        </div>
                    </b-col>
                  </b-row>
                  <b-card v-for="tOutcome in to.flexibility" v-bind:key="tOutcome._id" class="flex-card">
                      <b-row>
                        <b-col><b>Pod:</b> {{ tOutcome.pod }}</b-col>
                      </b-row>
                      <b-row>
                        <b-col><b>Power:</b></b-col>
                      </b-row>
                      <b-row>
                        <b-col>
                            <b-table
                              responsive
                              hover
                              bordered
                              outlined
                              small
                              :items="tOutcome.power"
                              :fields="fieldsTechinicalOutcome"
                              class="tablePower tablePower-hover table-platone">
                              <template #cell(index)="resultTo">
                                {{ resultTo.item.index }}
                              </template>
                              <template #cell(acceptedPValue)="resultTo">
                                {{ resultTo.item.acceptedPValue ? Math.round( resultTo.item.acceptedPValue* 1000)/1000
                                : resultTo.item.acceptedPValue | formatNumber | formatKw}}
                              </template>
                              <template #cell(acceptedQValue)="resultTo">
                                {{ resultTo.item.acceptedQValue ? Math.round( resultTo.item.acceptedQValue* 1000)/1000
                                : resultTo.item.acceptedQValue | formatNumber | formatQKw}}
                              </template>
                              <template #cell(acceptedP)="resultTo">
                                {{ resultTo.item.acceptedP }}
                              </template>
                              <template #cell(acceptedQ)="resultTo">
                                {{ resultTo.item.acceptedQ }}
                              </template>
                            </b-table>
                        </b-col>
                      </b-row>
                    </b-card>
                </b-card>
              </b-list-group-item>
            </b-list-group>
          </template>
      </b-tab>
      <b-tab title="Validated Outcome">
       <!-- <vue-json-pretty :data="validatedOutcome"></vue-json-pretty> -->
        <template>
            <b-list-group>
              <b-list-group-item
                v-for="vo in validatedOutcome"
                v-bind:key="vo._id">
                <b-card>
                   <b-row>
                    <b-col><b>Validated Outcome Id:</b> {{ vo._id }}</b-col>
                    <b-col md="9" offset-md="9">
                        <div class="md-layout-item md-small-size-20 md-size-20 md-alignment-center-right">
                          <b-btn class="xlsx-button" @click="exportToVoExcel(vo.flexibility, vo.marketType, vo.startTime)">Download Validate Outcome&nbsp;&nbsp;<b-icon icon="file-earmark-excel"/></b-btn>
                        </div>
                    </b-col>
                  </b-row>
                  <b-card v-for="vOutcome in vo.flexibility" v-bind:key="vOutcome._id" class="flex-card">
                      <b-row>
                        <b-col><b>Pod:</b> {{ vOutcome.pod }}</b-col>
                      </b-row>
                      <b-row>
                        <b-col><b>Power:</b></b-col>
                      </b-row>
                      <b-row>
                        <b-col>
                            <b-table
                              responsive
                              hover
                              bordered
                              outlined
                              small
                              :items="vOutcome.power"
                              :fields="fieldsValidatedOutcome"
                              class="tablePower tablePower-hover table-platone">
                              <template #cell(index)="resultVo">
                                {{ resultVo.item.index }}
                              </template>
                              <template #cell(acceptedPValue)="resultVo">
                                {{ resultVo.item.acceptedPValue ? Math.round( resultVo.item.acceptedPValue* 1000)/1000
                                : resultVo.item.acceptedPValue | formatNumber | formatKw}}
                              </template>
                              <template #cell(acceptedQValue)="resultVo">
                                {{ resultVo.item.acceptedQValue ? Math.round( resultVo.item.acceptedQValue* 1000)/1000
                                : resultVo.item.acceptedQValue | formatNumber | formatQKw}}
                              </template>
                              <template #cell(acceptedPPrice)="resultVo">
                                {{ resultVo.item.acceptedPPrice | formatNumber | formatPriceKw}}
                              </template>
                              <template #cell(acceptedQPrice)="resultVo">
                                {{ resultVo.item.acceptedQPrice | formatNumber | formatQPriceKw}}
                              </template>
                               <template #cell(acceptedPtype)="resultVo">
                                {{ resultVo.item.acceptedPtype }}
                              </template>
                              <template #cell(rejectionTypeP)="resultVo">
                                {{ resultVo.item.rejectionTypeP }}
                              </template>
                              <template #cell(rejectionTypeQ)="resultVo">
                                {{ resultVo.item.rejectionTypeQ }}
                              </template>
                              <template #cell(playerServiceId)="resultVo">
                                {{ resultVo.item.playerServiceId }}
                              </template>
                              <template #cell(playerRequestId)="resultVo">
                                {{ resultVo.item.playerRequestId }}
                              </template>
                              <template #cell(playerOfferId)="resultVo">
                                {{ resultVo.item.playerOfferId }}
                              </template>
                            </b-table>
                        </b-col>
                      </b-row>
                    </b-card>
                </b-card>
              </b-list-group-item>
            </b-list-group>
          </template>
      </b-tab>
      <b-tab title="Settlement">
      <!--  <vue-json-pretty :data="settlement"></vue-json-pretty>-->
       <template>
            <b-list-group>
              <b-list-group-item
                v-for="se in settlement"
                v-bind:key="se._id">
                <b-card>
                  <b-row>
                    <b-col><b>Settlement Id:</b> {{ se._id }}</b-col>
                  </b-row>
                   <b-row>
                    <b-col md="9" offset-md="9">
                        <div class="md-layout-item md-small-size-20 md-size-20 md-alignment-center-right">
                          <b-btn class="xlsx-button" @click="exportToSetExcel(se.flexibility, se.marketType, se.startTime)">Download Settlement&nbsp;&nbsp;<b-icon icon="file-earmark-excel"/></b-btn>
                        </div>
                    </b-col>
                  </b-row>
                  <b-card v-for="settlementObj in se.flexibility" v-bind:key="settlementObj._id" class="flex-card">
                      <b-row>
                        <b-col><b>Pod:</b> {{ settlementObj.pod }}</b-col>
                      </b-row>
                      <b-row>
                        <b-col><b>Power:</b></b-col>
                      </b-row>
                      <b-row>
                        <b-col>
                            <b-table
                              responsive
                              hover
                              bordered
                              outlined
                              small
                              :items="settlementObj.power"
                              :fields="fieldsSettlement"
                              class="tablePower tablePower-hover table-platone">
                              <template #cell(index)="resultSe">
                                {{ resultSe.item.index }}
                              </template>
                              <template #cell(requestedP)="resultSe">
                                {{resultSe.item.requestedP ? Math.round( resultSe.item.requestedP* 1000)/1000
                                : resultSe.item.requestedP | formatNumber | formatKw}}
                              </template>
                              <template #cell(measuredP)="resultSe">
                                {{(resultSe.item.measuredP || resultSe.item.measuredP===0) ? Math.round( resultSe.item.measuredP* 1000)/1000
                                : resultSe.item.measuredP | formatNumber | formatKw}}
                              </template>
                              <template #cell(paidP)="resultSe">
                                {{resultSe.item.paidP ? Math.round( resultSe.item.paidP* 1000)/1000
                                : resultSe.item.paidP | formatNumber | formatPrice}}
                              </template>
                              <template #cell(requestedQ)="resultSe">
                                {{resultSe.item.requestedQ ? Math.round( resultSe.item.requestedQ* 1000)/1000
                                : resultSe.item.requestedQ | formatNumber | formatQKw}}
                              </template>
                              <template #cell(measuredQ)="resultSe">
                                 {{resultSe.item.measuredQ ? Math.round( resultSe.item.measuredQ* 1000)/1000
                                : resultSe.item.measuredQ | formatNumber | formatQKw}}
                              </template>
                              <template #cell(paidQ)="resultSe">
                                 {{resultSe.item.paidQ ? Math.round( resultSe.item.paidQ* 1000)/1000
                                : resultSe.item.paidQ | formatNumber | formatPrice}}
                              </template>
                              <template #cell(requestPlayerId)="resultSe">
                                {{ resultSe.item.requestPlayerId }}
                              </template>
                              <template #cell(offerPlayerId)="resultSe">
                                {{ resultSe.item.offerPlayerId }}
                              </template>
                            </b-table>
                        </b-col>
                      </b-row>
                    </b-card>
                </b-card>
              </b-list-group-item>
            </b-list-group>
          </template>
      </b-tab>
    </b-tabs>
  </b-container>

</template>
<script>
import FlexibilityServicesService from '@/services/FlexibilityServicesService'
import MarketOutcomesServices from '@/services/MarketOutcomesServices'
import TechnicalOutcomesService from '@/services/TechnicalOutcomesService'
import ValidatedOutcomesService from '@/services/ValidatedOutcomesService'
import SettlementsService from '@/services/SettlementsService'
import * as XLSX from 'xlsx'

export default {
  mounted () {
    this.getFlexibilityServices()
    this.getMarketOutcome()
    this.getTechnicalOutcome()
    this.getValidatedOutcome()
    this.getSettlement()
  },
  data () {
    return {
      jsonData: JSON.stringify({ pippo: 'pluto' }),
      flexibilityServices: [],
      marketOutcome: [],
      technicalOutcome: [],
      validatedOutcome: [],
      settlement: [],
      fields: [
        { key: 'createdAt', label: 'Insert Date', sortable: true },
        { key: 'playerId', label: 'Market Operator', sortable: true },
        { key: 'playerServiceId', label: 'Player Service Id', sortable: true },
        { key: 'serviceType', label: 'Service Type', sortable: true },
        { key: 'marketType', label: 'MarketType', sortable: true },
        { key: 'flexibility', label: 'Flexibility' }
      ],
      fieldsPower: [
        { key: 'index', label: 'Index' },
        { key: 'p', label: 'p' },
        { key: 'pPrice', label: 'pPrice' },
        { key: 'q', label: 'q' },
        { key: 'qPrice', label: 'qPrice' }
      ],
      fieldsMarketOutcome: [
        { key: 'index', label: 'Index' },
        { key: 'p', label: 'p' },
        { key: 'priorityP', label: 'priorityP' },
        { key: 'q', label: 'q' },
        { key: 'priorityQ', label: 'priorityQ' }
      ],
      fieldsTechinicalOutcome: [
        { key: 'index', label: 'Index' },
        { key: 'acceptedPValue', label: 'acceptedPValue' },
        { key: 'acceptedQValue', label: 'acceptedQValue' },
        { key: 'acceptedP', label: 'acceptedP' },
        { key: 'acceptedQ', label: 'acceptedQ' }
      ],
      fieldsValidatedOutcome: [
        { key: 'index', label: 'Index' },
        { key: 'acceptedPValue', label: 'acceptedPValue' },
        { key: 'acceptedQValue', label: 'acceptedQValue' },
        { key: 'acceptedPPrice', label: 'acceptedPPrice' },
        { key: 'acceptedQPrice', label: 'acceptedQPrice' },
        { key: 'acceptedPtype', label: 'acceptedPtype' },
        { key: 'rejectionTypeP', label: 'rejectionTypeP' },
        { key: 'rejectionTypeQ', label: 'rejectionTypeQ' },
        { key: 'playerServiceId', label: 'playerServiceId' },
        { key: 'playerRequestId', label: 'playerRequestId' },
        { key: 'playerOfferId', label: 'playerOfferId' }
      ],
      fieldsSettlement: [
        { key: 'index', label: 'Index' },
        { key: 'requestedP', label: 'requestedP' },
        { key: 'measuredP', label: 'measuredP' },
        { key: 'paidP', label: 'paidP' },
        { key: 'requestedQ', label: 'requestedQ' },
        { key: 'measuredQ', label: 'measuredQ' },
        { key: 'paidQ', label: 'paidQ' },
        { key: 'requestPlayerId', label: 'requestPlayerId' },
        { key: 'offerPlayerId', label: 'offerPlayerId' }
      ],
      filter: null,
      options: {
        format: 'YYYY-MM-DD hh:mm:ss',
        useCurrent: false,
        minuteStep: Number(15)
      },
      currentPage: 1,
      perPage: 10,
      totalRows: 0
    }
  },
  methods: {
    async getFlexibilityServices () {
      const response = await FlexibilityServicesService.getByMarketSessions(this.$route.params.sessionId)
      console.log('Response getFlexibilityServices' + JSON.stringify(response.data))
      this.flexibilityServices = response.data
      this.totalRows = this.flexibilityServices.length
    },
    async getMarketOutcome () {
      const response = await MarketOutcomesServices.getByMarketSessions(this.$route.params.sessionId)
      console.log('Response getMarketOutcome' + JSON.stringify(response.data))
      this.marketOutcome = response.data
    },
    async getTechnicalOutcome () {
      const response = await TechnicalOutcomesService.getByMarketSessions(this.$route.params.sessionId)
      console.log('Response getTechnicalOutcome' + JSON.stringify(response.data))
      this.technicalOutcome = response.data
    },
    async getValidatedOutcome () {
      const response = await ValidatedOutcomesService.getByMarketSessions(this.$route.params.sessionId)
      console.log('Response getValidatedOutcome' + JSON.stringify(response.data))
      this.validatedOutcome = response.data
    },
    async getSettlement () {
      const response = await SettlementsService.getByMarketSessions(this.$route.params.sessionId)
      console.log('Response getSettlement' + JSON.stringify(response.data))
      this.settlement = response.data
    },
    onFiltered (filteredItems) {
      // Trigger pagination to update the number of buttons/pages due to filtering
      this.totalRows = filteredItems.length
      this.currentPage = 1
    },
    async exportToVoExcel (flexibilities, marketType, startTime) {
      let podsSheet
      const wb = XLSX.utils.book_new()

      for (let i = 0; i < flexibilities.length; i++) {
        const power = flexibilities[i].power
        let arrayFlex = []
        for (let j = 0; j < power.length; j++) {
          const powerObj = {
            index: power[j].index,
            acceptedPValue: power[j].acceptedPValue,
            acceptedQValue: power[j].acceptedQValue,
            acceptedPPrice: power[j].acceptedPPrice,
            acceptedQPrice: power[j].acceptedQPrice,
            acceptedPtype: power[j].acceptedPtype,
            rejectionTypeP: power[j].rejectionTypeP,
            rejectionTypeQ: power[j].rejectionTypeQ,
            playerServiceId: power[j].playerServiceId,
            playerRequestId: power[j].playerRequestId,
            playerOfferId: power[j].playerOfferId
          }
          arrayFlex.push(powerObj)
        }

        podsSheet = XLSX.utils.json_to_sheet(arrayFlex)
        XLSX.utils.book_append_sheet(wb, podsSheet, 'POD - ' + flexibilities[i].pod)
      }
      XLSX.writeFile(wb, 'validateOutcome' + '_' + marketType + '_' + startTime + '.xlsx')
    },
    async exportToFsExcel (result, serviceType) {
      let podsSheet
      const wb = XLSX.utils.book_new()
      const flexibilities = result.flexibility
      let pod
      let podName

      for (let i = 0; i < flexibilities.length; i++) {
        const power = flexibilities[i].power
        podName = flexibilities[i].pod
        let arrayFlex = []
        for (let j = 0; j < power.length; j++) {
          const powerObj = {
            index: power[j].index,
            p: power[j].p,
            pPrice: power[j].pPrice,
            q: power[j].q,
            qPrice: power[j].qPrice
          }
          arrayFlex.push(powerObj)
        }

        podsSheet = XLSX.utils.json_to_sheet(arrayFlex)
        if (serviceType === 'DSO_request') {
          const length = 28
          pod = podName.toString().substring(0, length) + '...'
          podName = ''
        }
        XLSX.utils.book_append_sheet(wb, podsSheet, pod)
      }
      XLSX.writeFile(wb, 'flexibilityService' + '_' + result.playerServiceId + '.xlsx')
    },
    async exportToMoExcel (flexibilities, marketType, startTime) {
      let podsSheet
      const wb = XLSX.utils.book_new()

      for (let i = 0; i < flexibilities.length; i++) {
        const power = flexibilities[i].power
        let arrayFlex = []
        for (let j = 0; j < power.length; j++) {
          const powerObj = {
            index: power[j].index,
            p: power[j].p,
            priorityP: power[j].priorityP,
            q: power[j].q,
            priorityQ: power[j].priorityQ
          }
          arrayFlex.push(powerObj)
        }

        podsSheet = XLSX.utils.json_to_sheet(arrayFlex)
        XLSX.utils.book_append_sheet(wb, podsSheet, 'POD - ' + flexibilities[i].pod)
      }
      XLSX.writeFile(wb, 'marketOutcome' + '_' + marketType + '_' + startTime + '.xlsx')
    },
    async exportToToExcel (flexibilities, marketType, startTime) {
      let podsSheet
      const wb = XLSX.utils.book_new()

      for (let i = 0; i < flexibilities.length; i++) {
        const power = flexibilities[i].power
        let arrayFlex = []
        for (let j = 0; j < power.length; j++) {
          const powerObj = {
            index: power[j].index,
            acceptedPValue: power[j].acceptedPValue,
            acceptedQValue: power[j].acceptedQValue,
            acceptedP: power[j].acceptedP,
            acceptedQ: power[j].acceptedQ
          }
          arrayFlex.push(powerObj)
        }

        podsSheet = XLSX.utils.json_to_sheet(arrayFlex)
        XLSX.utils.book_append_sheet(wb, podsSheet, 'POD - ' + flexibilities[i].pod)
      }
      XLSX.writeFile(wb, 'technicalOutcome' + '_' + marketType + '_' + startTime + '.xlsx')
    },
    async exportToSetExcel (flexibilities, marketType, startTime) {
      let podsSheet
      const wb = XLSX.utils.book_new()

      for (let i = 0; i < flexibilities.length; i++) {
        const power = flexibilities[i].power
        let arrayFlex = []
        for (let j = 0; j < power.length; j++) {
          const powerObj = {
            index: power[j].index,
            requestedP: power[j].requestedP,
            paidP: power[j].paidP,
            measuredQ: power[j].measuredQ,
            paidQ: power[j].paidQ,
            requestPlayerId: power[j].requestPlayerId,
            offerPlayerId: power[j].offerPlayerId
          }
          arrayFlex.push(powerObj)
        }

        podsSheet = XLSX.utils.json_to_sheet(arrayFlex)
        XLSX.utils.book_append_sheet(wb, podsSheet, 'POD - ' + flexibilities[i].pod)
      }
      XLSX.writeFile(wb, 'settlement' + '_' + marketType + '_' + startTime + '.xlsx')
    }
  }
}
</script>
<style>
  .ecube-button{
    margin-bottom: 10px;
  }
  .collapsed > .when-opened,
  :not(.collapsed) > .when-closed {
    display: none;
  }
  .consumers button {
    width: 140px;
    margin-bottom: 10px;
  }
  .tablePower thead {
    background-color: #497774;
    color: white;
  }
  .tablePower-hover thead tr th:hover, .tablePower-hover thead tr:hover th, .tablePower-hover thead tr:hover td, .tablePower-hover thead tr td:hover
  {
    color: white !important;
  }
  .flex-card {
    margin-top: 20px;
  }
  .xlsx-button {
    margin-bottom: 20px;
    background-color: #467572;
  }
</style>
